
#include "Parser.hpp"
#include <iostream>
#include <string>

using namespace std;

Parser::Parser(const char* u) {
    this->u = u;
}

char Parser::a()
{
    return *u;
}

char Parser::x_()
{
    return *u++;
}

MyInteger Parser::o()
{
    MyInteger i(x_() - '0');
    while (a() >= '0' && a() <= '9')
    {
        i = MyInteger(10 * i.getValue() + (x_() - '0'));
    }
    return i;
}

MyInteger Parser::w()
{
    if (a() >= '0' && a() <= '9')
        return o();
    else if (a() == '(')
    {
        x_(); // '('
        MyInteger i = q();
        x_(); // ')'
        return i;
    }
    else if (a() == '-')
    {
        x_();
        return -w();
    }
    return 0;
}

MyInteger Parser::pt()
{
    MyInteger i = w();
    while (a() == '*' || a() == '/')
        if (x_() == '*')
            i *= w();
        else
            i /= w();
    return i;
}

MyInteger Parser::q()
{
    MyInteger i = pt();
    while (a() == '+' || a() == '-')
        if (x_() == '+')
            i += pt();
        else
            i -= pt();
    return i;
}
